<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>SimpleCharStream.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute.compiler.generated</a> &gt; <span class="el_source">SimpleCharStream.java</span></div><h1>SimpleCharStream.java</h1><pre class="source lang-java linenums">/* Generated By:JavaCC: Do not edit this line. SimpleCharStream.java Version 4.0 */
/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute.compiler.generated;

/**
 * An implementation of interface CharStream, where the stream is assumed to
 * contain only ASCII characters (without unicode processing).
 */

public class SimpleCharStream
{
  public static final boolean staticFlag = false;
  int bufsize;
  int available;
  int tokenBegin;
<span class="nc" id="L33">  public int bufpos = -1;</span>
  protected int bufline[];
  protected int bufcolumn[];

<span class="nc" id="L37">  protected int column = 0;</span>
<span class="nc" id="L38">  protected int line = 1;</span>

<span class="nc" id="L40">  protected boolean prevCharIsCR = false;</span>
<span class="nc" id="L41">  protected boolean prevCharIsLF = false;</span>

  protected java.io.Reader inputStream;

  protected char[] buffer;
<span class="nc" id="L46">  protected int maxNextCharInd = 0;</span>
<span class="nc" id="L47">  protected int inBuf = 0;</span>
<span class="nc" id="L48">  protected int tabSize = 8;</span>

<span class="nc" id="L50">  protected void setTabSize(int i) { tabSize = i; }</span>
<span class="nc" id="L51">  protected int getTabSize(int i) { return tabSize; }</span>


  protected void ExpandBuff(boolean wrapAround)
  {
<span class="nc" id="L56">     char[] newbuffer = new char[bufsize + 2048];</span>
<span class="nc" id="L57">     int newbufline[] = new int[bufsize + 2048];</span>
<span class="nc" id="L58">     int newbufcolumn[] = new int[bufsize + 2048];</span>

     try
     {
<span class="nc bnc" id="L62" title="All 2 branches missed.">        if (wrapAround)</span>
        {
<span class="nc" id="L64">           System.arraycopy(buffer, tokenBegin, newbuffer, 0, bufsize - tokenBegin);</span>
<span class="nc" id="L65">           System.arraycopy(buffer, 0, newbuffer,</span>
                                             bufsize - tokenBegin, bufpos);
<span class="nc" id="L67">           buffer = newbuffer;</span>

<span class="nc" id="L69">           System.arraycopy(bufline, tokenBegin, newbufline, 0, bufsize - tokenBegin);</span>
<span class="nc" id="L70">           System.arraycopy(bufline, 0, newbufline, bufsize - tokenBegin, bufpos);</span>
<span class="nc" id="L71">           bufline = newbufline;</span>

<span class="nc" id="L73">           System.arraycopy(bufcolumn, tokenBegin, newbufcolumn, 0, bufsize - tokenBegin);</span>
<span class="nc" id="L74">           System.arraycopy(bufcolumn, 0, newbufcolumn, bufsize - tokenBegin, bufpos);</span>
<span class="nc" id="L75">           bufcolumn = newbufcolumn;</span>

<span class="nc" id="L77">           maxNextCharInd = (bufpos += (bufsize - tokenBegin));</span>
        }
        else
        {
<span class="nc" id="L81">           System.arraycopy(buffer, tokenBegin, newbuffer, 0, bufsize - tokenBegin);</span>
<span class="nc" id="L82">           buffer = newbuffer;</span>

<span class="nc" id="L84">           System.arraycopy(bufline, tokenBegin, newbufline, 0, bufsize - tokenBegin);</span>
<span class="nc" id="L85">           bufline = newbufline;</span>

<span class="nc" id="L87">           System.arraycopy(bufcolumn, tokenBegin, newbufcolumn, 0, bufsize - tokenBegin);</span>
<span class="nc" id="L88">           bufcolumn = newbufcolumn;</span>

<span class="nc" id="L90">           maxNextCharInd = (bufpos -= tokenBegin);</span>
        }
     }
<span class="nc" id="L93">     catch (Throwable t)</span>
     {
<span class="nc" id="L95">        throw new Error(t.getMessage());</span>
<span class="nc" id="L96">     }</span>


<span class="nc" id="L99">     bufsize += 2048;</span>
<span class="nc" id="L100">     available = bufsize;</span>
<span class="nc" id="L101">     tokenBegin = 0;</span>
<span class="nc" id="L102">  }</span>

  protected void FillBuff() throws java.io.IOException
  {
<span class="nc bnc" id="L106" title="All 2 branches missed.">     if (maxNextCharInd == available)</span>
     {
<span class="nc bnc" id="L108" title="All 2 branches missed.">        if (available == bufsize)</span>
        {
<span class="nc bnc" id="L110" title="All 2 branches missed.">           if (tokenBegin &gt; 2048)</span>
           {
<span class="nc" id="L112">              bufpos = maxNextCharInd = 0;</span>
<span class="nc" id="L113">              available = tokenBegin;</span>
           }
<span class="nc bnc" id="L115" title="All 2 branches missed.">           else if (tokenBegin &lt; 0)</span>
<span class="nc" id="L116">              bufpos = maxNextCharInd = 0;</span>
           else
<span class="nc" id="L118">              ExpandBuff(false);</span>
        }
<span class="nc bnc" id="L120" title="All 2 branches missed.">        else if (available &gt; tokenBegin)</span>
<span class="nc" id="L121">           available = bufsize;</span>
<span class="nc bnc" id="L122" title="All 2 branches missed.">        else if ((tokenBegin - available) &lt; 2048)</span>
<span class="nc" id="L123">           ExpandBuff(true);</span>
        else
<span class="nc" id="L125">           available = tokenBegin;</span>
     }

     int i;
     try {
<span class="nc bnc" id="L130" title="All 2 branches missed.">        if ((i = inputStream.read(buffer, maxNextCharInd,</span>
                                    available - maxNextCharInd)) == -1)
        {
<span class="nc" id="L133">           inputStream.close();</span>
<span class="nc" id="L134">           throw new java.io.IOException();</span>
        }
        else
<span class="nc" id="L137">           maxNextCharInd += i;</span>
<span class="nc" id="L138">        return;</span>
     }
<span class="nc" id="L140">     catch(java.io.IOException e) {</span>
<span class="nc" id="L141">        --bufpos;</span>
<span class="nc" id="L142">        backup(0);</span>
<span class="nc bnc" id="L143" title="All 2 branches missed.">        if (tokenBegin == -1)</span>
<span class="nc" id="L144">           tokenBegin = bufpos;</span>
<span class="nc" id="L145">        throw e;</span>
     }
  }

  public char BeginToken() throws java.io.IOException
  {
<span class="nc" id="L151">     tokenBegin = -1;</span>
<span class="nc" id="L152">     char c = readChar();</span>
<span class="nc" id="L153">     tokenBegin = bufpos;</span>

<span class="nc" id="L155">     return c;</span>
  }

  protected void UpdateLineColumn(char c)
  {
<span class="nc" id="L160">     column++;</span>

<span class="nc bnc" id="L162" title="All 2 branches missed.">     if (prevCharIsLF)</span>
     {
<span class="nc" id="L164">        prevCharIsLF = false;</span>
<span class="nc" id="L165">        line += (column = 1);</span>
     }
<span class="nc bnc" id="L167" title="All 2 branches missed.">     else if (prevCharIsCR)</span>
     {
<span class="nc" id="L169">        prevCharIsCR = false;</span>
<span class="nc bnc" id="L170" title="All 2 branches missed.">        if (c == '\n')</span>
        {
<span class="nc" id="L172">           prevCharIsLF = true;</span>
        }
        else
<span class="nc" id="L175">           line += (column = 1);</span>
     }

<span class="nc bnc" id="L178" title="All 4 branches missed.">     switch (c)</span>
     {
        case '\r' :
<span class="nc" id="L181">           prevCharIsCR = true;</span>
<span class="nc" id="L182">           break;</span>
        case '\n' :
<span class="nc" id="L184">           prevCharIsLF = true;</span>
<span class="nc" id="L185">           break;</span>
        case '\t' :
<span class="nc" id="L187">           column--;</span>
<span class="nc" id="L188">           column += (tabSize - (column % tabSize));</span>
<span class="nc" id="L189">           break;</span>
        default :
           break;
     }

<span class="nc" id="L194">     bufline[bufpos] = line;</span>
<span class="nc" id="L195">     bufcolumn[bufpos] = column;</span>
<span class="nc" id="L196">  }</span>

  public char readChar() throws java.io.IOException
  {
<span class="nc bnc" id="L200" title="All 2 branches missed.">     if (inBuf &gt; 0)</span>
     {
<span class="nc" id="L202">        --inBuf;</span>

<span class="nc bnc" id="L204" title="All 2 branches missed.">        if (++bufpos == bufsize)</span>
<span class="nc" id="L205">           bufpos = 0;</span>

<span class="nc" id="L207">        return buffer[bufpos];</span>
     }

<span class="nc bnc" id="L210" title="All 2 branches missed.">     if (++bufpos &gt;= maxNextCharInd)</span>
<span class="nc" id="L211">        FillBuff();</span>

<span class="nc" id="L213">     char c = buffer[bufpos];</span>

<span class="nc" id="L215">     UpdateLineColumn(c);</span>
<span class="nc" id="L216">     return (c);</span>
  }

  /**
   * @deprecated 
   * @see #getEndColumn
   */

  public int getColumn() {
<span class="nc" id="L225">     return bufcolumn[bufpos];</span>
  }

  /**
   * @deprecated 
   * @see #getEndLine
   */

  public int getLine() {
<span class="nc" id="L234">     return bufline[bufpos];</span>
  }

  public int getEndColumn() {
<span class="nc" id="L238">     return bufcolumn[bufpos];</span>
  }

  public int getEndLine() {
<span class="nc" id="L242">     return bufline[bufpos];</span>
  }

  public int getBeginColumn() {
<span class="nc" id="L246">     return bufcolumn[tokenBegin];</span>
  }

  public int getBeginLine() {
<span class="nc" id="L250">     return bufline[tokenBegin];</span>
  }

  public void backup(int amount) {

<span class="nc" id="L255">    inBuf += amount;</span>
<span class="nc bnc" id="L256" title="All 2 branches missed.">    if ((bufpos -= amount) &lt; 0)</span>
<span class="nc" id="L257">       bufpos += bufsize;</span>
<span class="nc" id="L258">  }</span>

  public SimpleCharStream(java.io.Reader dstream, int startline,
  int startcolumn, int buffersize)
<span class="nc" id="L262">  {</span>
<span class="nc" id="L263">    inputStream = dstream;</span>
<span class="nc" id="L264">    line = startline;</span>
<span class="nc" id="L265">    column = startcolumn - 1;</span>

<span class="nc" id="L267">    available = bufsize = buffersize;</span>
<span class="nc" id="L268">    buffer = new char[buffersize];</span>
<span class="nc" id="L269">    bufline = new int[buffersize];</span>
<span class="nc" id="L270">    bufcolumn = new int[buffersize];</span>
<span class="nc" id="L271">  }</span>

  public SimpleCharStream(java.io.Reader dstream, int startline,
                          int startcolumn)
  {
<span class="nc" id="L276">     this(dstream, startline, startcolumn, 4096);</span>
<span class="nc" id="L277">  }</span>

  public SimpleCharStream(java.io.Reader dstream)
  {
<span class="nc" id="L281">     this(dstream, 1, 1, 4096);</span>
<span class="nc" id="L282">  }</span>
  public void ReInit(java.io.Reader dstream, int startline,
  int startcolumn, int buffersize)
  {
<span class="nc" id="L286">    inputStream = dstream;</span>
<span class="nc" id="L287">    line = startline;</span>
<span class="nc" id="L288">    column = startcolumn - 1;</span>

<span class="nc bnc" id="L290" title="All 4 branches missed.">    if (buffer == null || buffersize != buffer.length)</span>
    {
<span class="nc" id="L292">      available = bufsize = buffersize;</span>
<span class="nc" id="L293">      buffer = new char[buffersize];</span>
<span class="nc" id="L294">      bufline = new int[buffersize];</span>
<span class="nc" id="L295">      bufcolumn = new int[buffersize];</span>
    }
<span class="nc" id="L297">    prevCharIsLF = prevCharIsCR = false;</span>
<span class="nc" id="L298">    tokenBegin = inBuf = maxNextCharInd = 0;</span>
<span class="nc" id="L299">    bufpos = -1;</span>
<span class="nc" id="L300">  }</span>

  public void ReInit(java.io.Reader dstream, int startline,
                     int startcolumn)
  {
<span class="nc" id="L305">     ReInit(dstream, startline, startcolumn, 4096);</span>
<span class="nc" id="L306">  }</span>

  public void ReInit(java.io.Reader dstream)
  {
<span class="nc" id="L310">     ReInit(dstream, 1, 1, 4096);</span>
<span class="nc" id="L311">  }</span>
  public SimpleCharStream(java.io.InputStream dstream, String encoding, int startline,
  int startcolumn, int buffersize) throws java.io.UnsupportedEncodingException
  {
<span class="nc bnc" id="L315" title="All 2 branches missed.">     this(encoding == null ? new java.io.InputStreamReader(dstream) : new java.io.InputStreamReader(dstream, encoding), startline, startcolumn, buffersize);</span>
<span class="nc" id="L316">  }</span>

  public SimpleCharStream(java.io.InputStream dstream, int startline,
  int startcolumn, int buffersize)
  {
<span class="nc" id="L321">     this(new java.io.InputStreamReader(dstream), startline, startcolumn, buffersize);</span>
<span class="nc" id="L322">  }</span>

  public SimpleCharStream(java.io.InputStream dstream, String encoding, int startline,
                          int startcolumn) throws java.io.UnsupportedEncodingException
  {
<span class="nc" id="L327">     this(dstream, encoding, startline, startcolumn, 4096);</span>
<span class="nc" id="L328">  }</span>

  public SimpleCharStream(java.io.InputStream dstream, int startline,
                          int startcolumn)
  {
<span class="nc" id="L333">     this(dstream, startline, startcolumn, 4096);</span>
<span class="nc" id="L334">  }</span>

  public SimpleCharStream(java.io.InputStream dstream, String encoding) throws java.io.UnsupportedEncodingException
  {
<span class="nc" id="L338">     this(dstream, encoding, 1, 1, 4096);</span>
<span class="nc" id="L339">  }</span>

  public SimpleCharStream(java.io.InputStream dstream)
  {
<span class="nc" id="L343">     this(dstream, 1, 1, 4096);</span>
<span class="nc" id="L344">  }</span>

  public void ReInit(java.io.InputStream dstream, String encoding, int startline,
                          int startcolumn, int buffersize) throws java.io.UnsupportedEncodingException
  {
<span class="nc bnc" id="L349" title="All 2 branches missed.">     ReInit(encoding == null ? new java.io.InputStreamReader(dstream) : new java.io.InputStreamReader(dstream, encoding), startline, startcolumn, buffersize);</span>
<span class="nc" id="L350">  }</span>

  public void ReInit(java.io.InputStream dstream, int startline,
                          int startcolumn, int buffersize)
  {
<span class="nc" id="L355">     ReInit(new java.io.InputStreamReader(dstream), startline, startcolumn, buffersize);</span>
<span class="nc" id="L356">  }</span>

  public void ReInit(java.io.InputStream dstream, String encoding) throws java.io.UnsupportedEncodingException
  {
<span class="nc" id="L360">     ReInit(dstream, encoding, 1, 1, 4096);</span>
<span class="nc" id="L361">  }</span>

  public void ReInit(java.io.InputStream dstream)
  {
<span class="nc" id="L365">     ReInit(dstream, 1, 1, 4096);</span>
<span class="nc" id="L366">  }</span>
  public void ReInit(java.io.InputStream dstream, String encoding, int startline,
                     int startcolumn) throws java.io.UnsupportedEncodingException
  {
<span class="nc" id="L370">     ReInit(dstream, encoding, startline, startcolumn, 4096);</span>
<span class="nc" id="L371">  }</span>
  public void ReInit(java.io.InputStream dstream, int startline,
                     int startcolumn)
  {
<span class="nc" id="L375">     ReInit(dstream, startline, startcolumn, 4096);</span>
<span class="nc" id="L376">  }</span>
  public String GetImage()
  {
<span class="nc bnc" id="L379" title="All 2 branches missed.">     if (bufpos &gt;= tokenBegin)</span>
<span class="nc" id="L380">        return new String(buffer, tokenBegin, bufpos - tokenBegin + 1);</span>
     else
<span class="nc" id="L382">        return new String(buffer, tokenBegin, bufsize - tokenBegin) +</span>
                              new String(buffer, 0, bufpos + 1);
  }

  public char[] GetSuffix(int len)
  {
<span class="nc" id="L388">     char[] ret = new char[len];</span>

<span class="nc bnc" id="L390" title="All 2 branches missed.">     if ((bufpos + 1) &gt;= len)</span>
<span class="nc" id="L391">        System.arraycopy(buffer, bufpos - len + 1, ret, 0, len);</span>
     else
     {
<span class="nc" id="L394">        System.arraycopy(buffer, bufsize - (len - bufpos - 1), ret, 0,</span>
                                                          len - bufpos - 1);
<span class="nc" id="L396">        System.arraycopy(buffer, 0, ret, len - bufpos - 1, bufpos + 1);</span>
     }

<span class="nc" id="L399">     return ret;</span>
  }

  public void Done()
  {
<span class="nc" id="L404">     buffer = null;</span>
<span class="nc" id="L405">     bufline = null;</span>
<span class="nc" id="L406">     bufcolumn = null;</span>
<span class="nc" id="L407">  }</span>

  /**
   * Method to adjust line and column numbers for the start of a token.
   */
  public void adjustBeginLineColumn(int newLine, int newCol)
  {
<span class="nc" id="L414">     int start = tokenBegin;</span>
     int len;

<span class="nc bnc" id="L417" title="All 2 branches missed.">     if (bufpos &gt;= tokenBegin)</span>
     {
<span class="nc" id="L419">        len = bufpos - tokenBegin + inBuf + 1;</span>
     }
     else
     {
<span class="nc" id="L423">        len = bufsize - tokenBegin + bufpos + 1 + inBuf;</span>
     }

<span class="nc" id="L426">     int i = 0, j = 0, k = 0;</span>
<span class="nc" id="L427">     int nextColDiff = 0, columnDiff = 0;</span>

<span class="nc bnc" id="L429" title="All 4 branches missed.">     while (i &lt; len &amp;&amp;</span>
            bufline[j = start % bufsize] == bufline[k = ++start % bufsize])
     {
<span class="nc" id="L432">        bufline[j] = newLine;</span>
<span class="nc" id="L433">        nextColDiff = columnDiff + bufcolumn[k] - bufcolumn[j];</span>
<span class="nc" id="L434">        bufcolumn[j] = newCol + columnDiff;</span>
<span class="nc" id="L435">        columnDiff = nextColDiff;</span>
<span class="nc" id="L436">        i++;</span>
     } 

<span class="nc bnc" id="L439" title="All 2 branches missed.">     if (i &lt; len)</span>
     {
<span class="nc" id="L441">        bufline[j] = newLine++;</span>
<span class="nc" id="L442">        bufcolumn[j] = newCol + columnDiff;</span>

<span class="nc bnc" id="L444" title="All 2 branches missed.">        while (i++ &lt; len)</span>
        {
<span class="nc bnc" id="L446" title="All 2 branches missed.">           if (bufline[j = start % bufsize] != bufline[++start % bufsize])</span>
<span class="nc" id="L447">              bufline[j] = newLine++;</span>
           else
<span class="nc" id="L449">              bufline[j] = newLine;</span>
        }
     }

<span class="nc" id="L453">     line = bufline[j];</span>
<span class="nc" id="L454">     column = bufcolumn[j];</span>
<span class="nc" id="L455">  }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>